/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package fxdemo;

import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.event.EventType;
import javafx.geometry.Insets;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.HBox;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;

/**
 *
 * @author micha
 */
public class FxDemo extends Application {

    public class Btn2EventHandler implements EventHandler<ActionEvent> {
        @Override
        public void handle(ActionEvent event) {
            System.out.println("moin moin");
        }
    }

    @Override
    //Application ist abstrakt, start(Stage) muss ueberschrieben werden
    //Stage entspricht JFrame
    public void start(Stage primaryStage) {

        //Button erbt von Node
        //Node-objekte entsprechen JComponent-objekten
        Button btnCenter = new Button();
        btnCenter.setText("international");

        //mit lambda operator
        // (int x, int y) -> {return x+y;}
        // (x, y) -> {return x+y;}
        // x -> 2*x;
        
        btnCenter.setOnAction((e) -> {
            for (int i = 0; i < 3; i++) {
                System.out.printf("hi ");    
            }
            System.out.println("my little droogies");
        });
        
        //weitere knoepfe
        Button btn1 = new Button("sach tach");
        Button btn2 = new Button("ostfriesisch");
        Button btn3 = new Button("alemanisch");

        btn1.setOnAction(new Btn1EventHandler());
        btn2.setOnAction(new FxDemo.Btn2EventHandler());
        btn3.setOnAction(new EventHandler<ActionEvent>(){
        @Override
        public void handle(ActionEvent event) {
            System.out.println("salli an alli"
                    + "");
        }
        });
        
        VBox rechts = new VBox();

        rechts.setPadding(new Insets(10));
        rechts.setSpacing(8);
        rechts.getChildren().addAll(btn1, btn2, btn3);

        BorderPane root = new BorderPane();
        root.setCenter(btnCenter);
        root.setRight(rechts);

        //3 komponenten erzeugen
        Label lblLinks = new Label("Links");
        Label lblRechts = new Label("Rechts");
        TextField mitte = new TextField();

        HBox unten = new HBox(20);
        unten.getChildren().addAll(lblLinks, mitte, lblRechts);
        root.setBottom(unten);

        //Scene entspricht in etwa das, was JFrame.getContentPane() liefert
        //d.h. Scene ist ein container
        Scene scene = new Scene(root, 300, 250);

        primaryStage.setTitle("Hello World!");
        primaryStage.setScene(scene);
        primaryStage.show();
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        launch(args);
    }

}
